﻿# Author: Garth Jones
# http://www.enhansoft.com
#
# Created Date: 2016-08-01
# Version: 1.00
#
# Thanks Sean Kearney @energizedtech for the start point. 
# 

##################################################################
#                   User Defined Variables
##################################################################

Clear-Host
$CSVPath='C:\temp\'
$CSVName ='computerlist.csv'
$Downtime = 5
$Uptime = 60


# Test for the CSV file
if (test-path -Path $CSVPath$CSVName)
{
    $Start=$True
    write-host "Starting VM"
}
else
{
    $Start=$False
    write-host "Stopping VM"
}

# Starting the VMs
If ($Start)
{
    $vmlist = Import-CSV -Path $CSVPath$CSVName

    Foreach ($VM in $VMlist)
    {
        write-host "Starting VM: $VM.VMname"
        Start-VM -Name $VM.VMname 
        write-host "Sleeping $Uptime seconds"
        start-sleep $Uptime 
    }
    Remove-Item $CSVPath$CSVName
    write-host "Deleting: $CSVPath$CSVName"
}
else
{
# Staopping the VMs
    New-Item -Path $CSVPath -Name $CSVName -ItemType File -Force
    Add-Content -path $CSVPath$CSVName -value VMname
    GET-VM | where {$_.state -eq ‘running’} | Select-Object -expandproperty Name | foreach { Add-Content -Path $CSVPath$CSVName -value $_} 
    $vmlist = Import-CSV -Path $CSVPath$CSVName

    Foreach ($VM in $VMlist)
    {
        write-host "Stopping VM: $VM.VMname"
        Stop-VM -Name $VM.VMname -force
        write-host "Sleeping $Downtime seconds"
        start-sleep $Downtime

    }

    write-host "Rebooting Server"
    
    # Reboot the Server 
    # Uncomment the next line to reboot the server

    # Restart-Computer -Force
}
